/* linpacks.f -- translated by f2c (version of 16 May 1991  13:06:06).
   You must link the resulting object file with the libraries:
	-link <S|C|M|L>f2c.lib   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static real c_b7 = (float)1.;
static integer c__1 = 1;

/* Main program */ MAIN__()
{
    /* Format strings */
    static char fmt_1[] = "(\002 Please send the results of this run to:\002\
//\002 Jack J. Dongarra\002/\002 Computer Science Department\002/\002 Univer\
sity of Tennessee\002/\002 Knoxville, Tennessee 37996-1300\002//\002 Fax: 61\
5-974-8296\002//\002 Internet: dongarra@cs.utk.edu\002/)";
    static char fmt_40[] = "(\002     norm. resid      resid           mac\
hep\002,\002         x(1)          x(n)\002)";
    static char fmt_50[] = "(1p5e16.8)";
    static char fmt_60[] = "(//\002    times are reported for matrices of or\
der \002,i5)";
    static char fmt_70[] = "(6x,\002sgefa\002,6x,\002sgesl\002,6x,\002tota\
l\002,5x,\002mflops\002,7x,\002unit\002,6x,\002ratio\002)";
    static char fmt_80[] = "(\002 times for array with leading dimension o\
f\002,i4)";
    static char fmt_110[] = "(6(1pe11.3))";
    static char fmt_140[] = "(/\002 times for array with leading dimension\
 of\002,i4)";

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3;

    /* Builtin functions */
    integer s_wsfe(), e_wsfe(), do_fio();
    /* Subroutine */ int s_stop();

    /* Local variables */
    static integer ldaa, info;
    static real time[48]	/* was [8][6] */, cray;
    static integer ipvt[200];
    static real a[40200]	/* was [201][200] */, b[200];
    static integer i, n;
    extern /* Subroutine */ int sgefa_();
    static real x[200], resid, norma;
    extern /* Subroutine */ int sgesl_();
    static real total, normx, t1;
    extern /* Subroutine */ int smxpy_();
    static real aa[40000]	/* was [200][200] */, tm;
    extern /* Subroutine */ int matgen_();
    extern doublereal second_();
    static real residn;
    static integer ntimes;
    extern doublereal epslon_();
    static real tm2;
    static integer lda;
    static real eps, ops;

    /* Fortran I/O blocks */
    static cilist io___5 = { 0, 6, 0, fmt_1, 0 };
    static cilist io___21 = { 0, 6, 0, fmt_40, 0 };
    static cilist io___22 = { 0, 6, 0, fmt_50, 0 };
    static cilist io___23 = { 0, 6, 0, fmt_60, 0 };
    static cilist io___24 = { 0, 6, 0, fmt_70, 0 };
    static cilist io___25 = { 0, 6, 0, fmt_80, 0 };
    static cilist io___26 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___30 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___31 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___32 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___34 = { 0, 6, 0, fmt_140, 0 };
    static cilist io___35 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___36 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___37 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___38 = { 0, 6, 0, fmt_110, 0 };


    lda = 201;
    ldaa = 200;

    n = 100;
    cray = (float).056;
    s_wsfe(&io___5);
    e_wsfe();
/* Computing 3rd power */
    i__1 = n, i__2 = i__1;
/* Computing 2nd power */
    i__3 = n;
    ops = i__2 * (i__1 * i__1) * (float)2. / (float)3. + i__3 * i__3 * (float)
	    2.;

    matgen_(a, &lda, &n, b, &norma);
    t1 = second_();
    sgefa_(a, &lda, &n, ipvt, &info);
    time[0] = second_() - t1;
    t1 = second_();
    sgesl_(a, &lda, &n, ipvt, b, &c__0);
    time[8] = second_() - t1;
    total = time[0] + time[8];

/*     COMPUTE A RESIDUAL TO VERIFY RESULTS. */

    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
	x[i - 1] = b[i - 1];
/* L10: */
    }
    matgen_(a, &lda, &n, b, &norma);
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
	b[i - 1] = -(doublereal)b[i - 1];
/* L20: */
    }
    smxpy_(&n, b, &n, &lda, x, a);
    resid = (float)0.;
    normx = (float)0.;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
/* Computing MAX */
	r__2 = resid, r__3 = (r__1 = b[i - 1], dabs(r__1));
	resid = dmax(r__2,r__3);
/* Computing MAX */
	r__2 = normx, r__3 = (r__1 = x[i - 1], dabs(r__1));
	normx = dmax(r__2,r__3);
/* L30: */
    }
    eps = epslon_(&c_b7);
    residn = resid / (n * norma * normx * eps);
    s_wsfe(&io___21);
    e_wsfe();
    s_wsfe(&io___22);
    do_fio(&c__1, (char *)&residn, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&resid, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&eps, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&x[0], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&x[n - 1], (ftnlen)sizeof(real));
    e_wsfe();

    s_wsfe(&io___23);
    do_fio(&c__1, (char *)&n, (ftnlen)sizeof(integer));
    e_wsfe();
    s_wsfe(&io___24);
    e_wsfe();

    time[16] = total;
    time[24] = ops / (total * (float)1e6);
    time[32] = (float)2. / time[24];
    time[40] = total / cray;
    s_wsfe(&io___25);
    do_fio(&c__1, (char *)&lda, (ftnlen)sizeof(integer));
    e_wsfe();
    s_wsfe(&io___26);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 8], (ftnlen)sizeof(real));
    }
    e_wsfe();

    matgen_(a, &lda, &n, b, &norma);
    t1 = second_();
    sgefa_(a, &lda, &n, ipvt, &info);
    time[1] = second_() - t1;
    t1 = second_();
    sgesl_(a, &lda, &n, ipvt, b, &c__0);
    time[9] = second_() - t1;
    total = time[1] + time[9];
    time[17] = total;
    time[25] = ops / (total * (float)1e6);
    time[33] = (float)2. / time[25];
    time[41] = total / cray;

    matgen_(a, &lda, &n, b, &norma);
    t1 = second_();
    sgefa_(a, &lda, &n, ipvt, &info);
    time[2] = second_() - t1;
    t1 = second_();
    sgesl_(a, &lda, &n, ipvt, b, &c__0);
    time[10] = second_() - t1;
    total = time[2] + time[10];
    time[18] = total;
    time[26] = ops / (total * (float)1e6);
    time[34] = (float)2. / time[26];
    time[42] = total / cray;

    ntimes = 10;
    tm2 = (float)0.;
    t1 = second_();
    i__1 = ntimes;
    for (i = 1; i <= i__1; ++i) {
	tm = second_();
	matgen_(a, &lda, &n, b, &norma);
	tm2 = tm2 + second_() - tm;
	sgefa_(a, &lda, &n, ipvt, &info);
/* L90: */
    }
    time[3] = (second_() - t1 - tm2) / ntimes;
    t1 = second_();
    i__1 = ntimes;
    for (i = 1; i <= i__1; ++i) {
	sgesl_(a, &lda, &n, ipvt, b, &c__0);
/* L100: */
    }
    time[11] = (second_() - t1) / ntimes;
    total = time[3] + time[11];
    time[19] = total;
    time[27] = ops / (total * (float)1e6);
    time[35] = (float)2. / time[27];
    time[43] = total / cray;

    s_wsfe(&io___30);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 7], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_wsfe(&io___31);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 6], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_wsfe(&io___32);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 5], (ftnlen)sizeof(real));
    }
    e_wsfe();

    matgen_(aa, &ldaa, &n, b, &norma);
    t1 = second_();
    sgefa_(aa, &ldaa, &n, ipvt, &info);
    time[4] = second_() - t1;
    t1 = second_();
    sgesl_(aa, &ldaa, &n, ipvt, b, &c__0);
    time[12] = second_() - t1;
    total = time[4] + time[12];
    time[20] = total;
    time[28] = ops / (total * (float)1e6);
    time[36] = (float)2. / time[28];
    time[44] = total / cray;

    matgen_(aa, &ldaa, &n, b, &norma);
    t1 = second_();
    sgefa_(aa, &ldaa, &n, ipvt, &info);
    time[5] = second_() - t1;
    t1 = second_();
    sgesl_(aa, &ldaa, &n, ipvt, b, &c__0);
    time[13] = second_() - t1;
    total = time[5] + time[13];
    time[21] = total;
    time[29] = ops / (total * (float)1e6);
    time[37] = (float)2. / time[29];
    time[45] = total / cray;

    matgen_(aa, &ldaa, &n, b, &norma);
    t1 = second_();
    sgefa_(aa, &ldaa, &n, ipvt, &info);
    time[6] = second_() - t1;
    t1 = second_();
    sgesl_(aa, &ldaa, &n, ipvt, b, &c__0);
    time[14] = second_() - t1;
    total = time[6] + time[14];
    time[22] = total;
    time[30] = ops / (total * (float)1e6);
    time[38] = (float)2. / time[30];
    time[46] = total / cray;

    ntimes = 10;
    tm2 = (float)0.;
    t1 = second_();
    i__1 = ntimes;
    for (i = 1; i <= i__1; ++i) {
	tm = second_();
	matgen_(aa, &ldaa, &n, b, &norma);
	tm2 = tm2 + second_() - tm;
	sgefa_(aa, &ldaa, &n, ipvt, &info);
/* L120: */
    }
    time[7] = (second_() - t1 - tm2) / ntimes;
    t1 = second_();
    i__1 = ntimes;
    for (i = 1; i <= i__1; ++i) {
	sgesl_(aa, &ldaa, &n, ipvt, b, &c__0);
/* L130: */
    }
    time[15] = (second_() - t1) / ntimes;
    total = time[7] + time[15];
    time[23] = total;
    time[31] = ops / (total * (float)1e6);
    time[39] = (float)2. / time[31];
    time[47] = total / cray;

    s_wsfe(&io___34);
    do_fio(&c__1, (char *)&ldaa, (ftnlen)sizeof(integer));
    e_wsfe();
    s_wsfe(&io___35);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 4], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_wsfe(&io___36);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 3], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_wsfe(&io___37);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 2], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_wsfe(&io___38);
    for (i = 1; i <= 6; ++i) {
	do_fio(&c__1, (char *)&time[(i << 3) - 1], (ftnlen)sizeof(real));
    }
    e_wsfe();
    s_stop("", 0L);
} /* MAIN__ */

/* Subroutine */ int matgen_(a, lda, n, b, norma)
real *a;
integer *lda, *n;
real *b, *norma;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1, r__2;

    /* Local variables */
    static integer init, i, j;


    /* Parameter adjustments */
    --b;
    a_dim1 = *lda;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    init = 1325;
    *norma = (float)0.;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
	    init = init * 3125 % 65536;
	    a[i + j * a_dim1] = (init - (float)32768.) / (float)16384.;
/* Computing MAX */
	    r__2 = (r__1 = a[i + j * a_dim1], dabs(r__1));
	    *norma = dmax(r__2,*norma);
/* L20: */
	}
/* L30: */
    }
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	b[i] = (float)0.;
/* L35: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
	    b[i] += a[i + j * a_dim1];
/* L40: */
	}
/* L50: */
    }
    return 0;
} /* matgen_ */

/* Subroutine */ int sgefa_(a, lda, n, ipvt, info)
real *a;
integer *lda, *n, *ipvt, *info;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer j, k, l;
    static real t;
    extern /* Subroutine */ int sscal_(), saxpy_();
    extern integer isamax_();
    static integer kp1, nm1;


/*     sgefa factors a real matrix by gaussian elimination. */

/*     sgefa is usually called by dgeco, but it can be called */
/*     directly with a saving in time if  rcond  is not needed. */
/*     (time for dgeco) = (1 + 9/n)*(time for sgefa) . */

/*     on entry */

/*        a       real(lda, n) */
/*                the matrix to be factored. */

/*        lda     integer */
/*                the leading dimension of the array  a . */

/*        n       integer */
/*                the order of the matrix  a . */

/*     on return */

/*        a       an upper triangular matrix and the multipliers */
/*                which were used to obtain it. */
/*                the factorization can be written  a = l*u  where */
/*                l  is a product of permutation and unit lower */
/*                triangular matrices and  u  is upper triangular. */

/*        ipvt    integer(n) */
/*                an integer vector of pivot indices. */

/*        info    integer */
/*                = 0  normal value. */
/*                = k  if  u(k,k) .eq. 0.0 .  this is not an error */
/*                     condition for this subroutine, but it does */
/*                     indicate that sgesl or dgedi will divide by zero */

/*                     if called.  use  rcond  in dgeco for a reliable */
/*                     indication of singularity. */

/*     linpack. this version dated 08/14/78 . */
/*     cleve moler, university of new mexico, argonne national lab. */

/*     subroutines and functions */

/*     blas saxpy,sscal,isamax */

/*     internal variables */



/*     gaussian elimination with partial pivoting */

    /* Parameter adjustments */
    --ipvt;
    a_dim1 = *lda;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *info = 0;
    nm1 = *n - 1;
    if (nm1 < 1) {
	goto L70;
    }
    i__1 = nm1;
    for (k = 1; k <= i__1; ++k) {
	kp1 = k + 1;

/*        find l = pivot index */

	i__2 = *n - k + 1;
	l = isamax_(&i__2, &a[k + k * a_dim1], &c__1) + k - 1;
	ipvt[k] = l;

/*        zero pivot implies this column already triangularized */

	if (a[l + k * a_dim1] == (float)0.) {
	    goto L40;
	}

/*           interchange if necessary */

	if (l == k) {
	    goto L10;
	}
	t = a[l + k * a_dim1];
	a[l + k * a_dim1] = a[k + k * a_dim1];
	a[k + k * a_dim1] = t;
L10:

/*           compute multipliers */

	t = (float)-1. / a[k + k * a_dim1];
	i__2 = *n - k;
	sscal_(&i__2, &t, &a[k + 1 + k * a_dim1], &c__1);

/*           row elimination with column indexing */

	i__2 = *n;
	for (j = kp1; j <= i__2; ++j) {
	    t = a[l + j * a_dim1];
	    if (l == k) {
		goto L20;
	    }
	    a[l + j * a_dim1] = a[k + j * a_dim1];
	    a[k + j * a_dim1] = t;
L20:
	    i__3 = *n - k;
	    saxpy_(&i__3, &t, &a[k + 1 + k * a_dim1], &c__1, &a[k + 1 + j * 
		    a_dim1], &c__1);
/* L30: */
	}
	goto L50;
L40:
	*info = k;
L50:
/* L60: */
	;
    }
L70:
    ipvt[*n] = *n;
    if (a[*n + *n * a_dim1] == (float)0.) {
	*info = *n;
    }
    return 0;
} /* sgefa_ */

/* Subroutine */ int sgesl_(a, lda, n, ipvt, b, job)
real *a;
integer *lda, *n, *ipvt;
real *b;
integer *job;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;

    /* Local variables */
    extern doublereal sdot_();
    static integer k, l;
    static real t;
    extern /* Subroutine */ int saxpy_();
    static integer kb, nm1;


/*     sgesl solves the real system */
/*     a * x = b  or  trans(a) * x = b */
/*     using the factors computed by dgeco or sgefa. */

/*     on entry */

/*        a       real(lda, n) */
/*                the output from dgeco or sgefa. */

/*        lda     integer */
/*                the leading dimension of the array  a . */

/*        n       integer */
/*                the order of the matrix  a . */

/*        ipvt    integer(n) */
/*                the pivot vector from dgeco or sgefa. */

/*        b       real(n) */
/*                the right hand side vector. */

/*        job     integer */
/*                = 0         to solve  a*x = b , */
/*                = nonzero   to solve  trans(a)*x = b  where */
/*                            trans(a)  is the transpose. */

/*     on return */

/*        b       the solution vector  x . */

/*     error condition */

/*        a division by zero will occur if the input factor contains a */
/*        zero on the diagonal.  technically this indicates singularity */

/*        but it is often caused by improper arguments or improper */
/*        setting of lda .  it will not occur if the subroutines are */
/*        called correctly and if dgeco has set rcond .gt. 0.0 */
/*        or sgefa has set info .eq. 0 . */

/*     to compute  inverse(a) * c  where  c  is a matrix */
/*     with  p  columns */
/*           call dgeco(a,lda,n,ipvt,rcond,z) */
/*           if (rcond is too small) go to ... */
/*           do 10 j = 1, p */
/*              call sgesl(a,lda,n,ipvt,c(1,j),0) */
/*        10 continue */

/*     linpack. this version dated 08/14/78 . */
/*     cleve moler, university of new mexico, argonne national lab. */

/*     subroutines and functions */

/*     blas saxpy,sdot */

/*     internal variables */


    /* Parameter adjustments */
    --b;
    --ipvt;
    a_dim1 = *lda;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    nm1 = *n - 1;
    if (*job != 0) {
	goto L50;
    }

/*        job = 0 , solve  a * x = b */
/*        first solve  l*y = b */

    if (nm1 < 1) {
	goto L30;
    }
    i__1 = nm1;
    for (k = 1; k <= i__1; ++k) {
	l = ipvt[k];
	t = b[l];
	if (l == k) {
	    goto L10;
	}
	b[l] = b[k];
	b[k] = t;
L10:
	i__2 = *n - k;
	saxpy_(&i__2, &t, &a[k + 1 + k * a_dim1], &c__1, &b[k + 1], &c__1);
/* L20: */
    }
L30:

/*        now solve  u*x = y */

    i__1 = *n;
    for (kb = 1; kb <= i__1; ++kb) {
	k = *n + 1 - kb;
	b[k] /= a[k + k * a_dim1];
	t = -(doublereal)b[k];
	i__2 = k - 1;
	saxpy_(&i__2, &t, &a[k * a_dim1 + 1], &c__1, &b[1], &c__1);
/* L40: */
    }
    goto L100;
L50:

/*        job = nonzero, solve  trans(a) * x = b */
/*        first solve  trans(u)*y = b */

    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	i__2 = k - 1;
	t = sdot_(&i__2, &a[k * a_dim1 + 1], &c__1, &b[1], &c__1);
	b[k] = (b[k] - t) / a[k + k * a_dim1];
/* L60: */
    }

/*        now solve trans(l)*x = y */

    if (nm1 < 1) {
	goto L90;
    }
    i__1 = nm1;
    for (kb = 1; kb <= i__1; ++kb) {
	k = *n - kb;
	i__2 = *n - k;
	b[k] += sdot_(&i__2, &a[k + 1 + k * a_dim1], &c__1, &b[k + 1], &c__1);

	l = ipvt[k];
	if (l == k) {
	    goto L70;
	}
	t = b[l];
	b[l] = b[k];
	b[k] = t;
L70:
/* L80: */
	;
    }
L90:
L100:
    return 0;
} /* sgesl_ */

/* Subroutine */ int saxpy_(n, da, dx, incx, dy, incy)
integer *n;
real *da, *dx;
integer *incx;
real *dy;
integer *incy;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i, ix, iy;


/*     constant times a vector plus a vector. */
/*     jack dongarra, linpack, 3/11/78. */


    /* Parameter adjustments */
    --dy;
    --dx;

    /* Function Body */
    if (*n <= 0) {
	return 0;
    }
    if (*da == (float)0.) {
	return 0;
    }
    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

/*        code for unequal increments or equal increments */
/*          not equal to 1 */

    ix = 1;
    iy = 1;
    if (*incx < 0) {
	ix = (-(*n) + 1) * *incx + 1;
    }
    if (*incy < 0) {
	iy = (-(*n) + 1) * *incy + 1;
    }
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dy[iy] += *da * dx[ix];
	ix += *incx;
	iy += *incy;
/* L10: */
    }
    return 0;

/*        code for both increments equal to 1 */

L20:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dy[i] += *da * dx[i];
/* L30: */
    }
    return 0;
} /* saxpy_ */

doublereal sdot_(n, dx, incx, dy, incy)
integer *n;
real *dx;
integer *incx;
real *dy;
integer *incy;
{
    /* System generated locals */
    integer i__1;
    real ret_val;

    /* Local variables */
    static integer i;
    static real dtemp;
    static integer ix, iy;


/*     forms the dot product of two vectors. */
/*     jack dongarra, linpack, 3/11/78. */


    /* Parameter adjustments */
    --dy;
    --dx;

    /* Function Body */
    ret_val = (float)0.;
    dtemp = (float)0.;
    if (*n <= 0) {
	return ret_val;
    }
    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

/*        code for unequal increments or equal increments */
/*          not equal to 1 */

    ix = 1;
    iy = 1;
    if (*incx < 0) {
	ix = (-(*n) + 1) * *incx + 1;
    }
    if (*incy < 0) {
	iy = (-(*n) + 1) * *incy + 1;
    }
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dtemp += dx[ix] * dy[iy];
	ix += *incx;
	iy += *incy;
/* L10: */
    }
    ret_val = dtemp;
    return ret_val;

/*        code for both increments equal to 1 */

L20:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dtemp += dx[i] * dy[i];
/* L30: */
    }
    ret_val = dtemp;
    return ret_val;
} /* sdot_ */

/* Subroutine */ int sscal_(n, da, dx, incx)
integer *n;
real *da, *dx;
integer *incx;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer i, nincx;


/*     scales a vector by a constant. */
/*     jack dongarra, linpack, 3/11/78. */


    /* Parameter adjustments */
    --dx;

    /* Function Body */
    if (*n <= 0) {
	return 0;
    }
    if (*incx == 1) {
	goto L20;
    }

/*        code for increment not equal to 1 */

    nincx = *n * *incx;
    i__1 = nincx;
    i__2 = *incx;
    for (i = 1; i__2 < 0 ? i >= i__1 : i <= i__1; i += i__2) {
	dx[i] = *da * dx[i];
/* L10: */
    }
    return 0;

/*        code for increment equal to 1 */

L20:
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	dx[i] = *da * dx[i];
/* L30: */
    }
    return 0;
} /* sscal_ */

integer isamax_(n, dx, incx)
integer *n;
real *dx;
integer *incx;
{
    /* System generated locals */
    integer ret_val, i__1;
    real r__1;

    /* Local variables */
    static real dmax_;
    static integer i, ix;


/*     finds the index of element having max. absolute value. */
/*     jack dongarra, linpack, 3/11/78. */


    /* Parameter adjustments */
    --dx;

    /* Function Body */
    ret_val = 0;
    if (*n < 1) {
	return ret_val;
    }
    ret_val = 1;
    if (*n == 1) {
	return ret_val;
    }
    if (*incx == 1) {
	goto L20;
    }

/*        code for increment not equal to 1 */

    ix = 1;
    dmax_ = dabs(dx[1]);
    ix += *incx;
    i__1 = *n;
    for (i = 2; i <= i__1; ++i) {
	if ((r__1 = dx[ix], dabs(r__1)) <= dmax_) {
	    goto L5;
	}
	ret_val = i;
	dmax_ = (r__1 = dx[ix], dabs(r__1));
L5:
	ix += *incx;
/* L10: */
    }
    return ret_val;

/*        code for increment equal to 1 */

L20:
    dmax_ = dabs(dx[1]);
    i__1 = *n;
    for (i = 2; i <= i__1; ++i) {
	if ((r__1 = dx[i], dabs(r__1)) <= dmax_) {
	    goto L30;
	}
	ret_val = i;
	dmax_ = (r__1 = dx[i], dabs(r__1));
L30:
	;
    }
    return ret_val;
} /* isamax_ */

doublereal epslon_(x)
real *x;
{
    /* System generated locals */
    real ret_val, r__1;

    /* Local variables */
    static real a, b, c, eps;


/*     ESTIMATE UNIT ROUNDOFF IN QUANTITIES OF SIZE X. */


/*     THIS PROGRAM SHOULD FUNCTION PROPERLY ON ALL SYSTEMS */
/*     SATISFYING THE FOLLOWING TWO ASSUMPTIONS, */
/*        1.  THE BASE USED IN REPRESENTING FLOATING POINT */
/*            NUMBERS IS NOT A POWER OF THREE. */
/*        2.  THE QUANTITY  A  IN STATEMENT 10 IS REPRESENTED TO */
/*            THE ACCURACY USED IN FLOATING POINT VARIABLES */
/*            THAT ARE STORED IN MEMORY. */
/*     THE STATEMENT NUMBER 10 AND THE GO TO 10 ARE INTENDED TO */
/*     FORCE OPTIMIZING COMPILERS TO GENERATE CODE SATISFYING */
/*     ASSUMPTION 2. */
/*     UNDER THESE ASSUMPTIONS, IT SHOULD BE TRUE THAT, */
/*            A  IS NOT EXACTLY EQUAL TO FOUR-THIRDS, */
/*            B  HAS A ZERO FOR ITS LAST BIT OR DIGIT, */
/*            C  IS NOT EXACTLY EQUAL TO ONE, */
/*            EPS  MEASURES THE SEPARATION OF 1.0 FROM */
/*                 THE NEXT LARGER FLOATING POINT NUMBER. */
/*     THE DEVELOPERS OF EISPACK WOULD APPRECIATE BEING INFORMED */
/*     ABOUT ANY SYSTEMS WHERE THESE ASSUMPTIONS DO NOT HOLD. */

/*     ***************************************************************** 
*/
/*     THIS ROUTINE IS ONE OF THE AUXILIARY ROUTINES USED BY EISPACK III 
*/
/*     TO AVOID MACHINE DEPENDENCIES. */
/*     ***************************************************************** 
*/

/*     THIS VERSION DATED 4/6/83. */

    a = (float)1.333333333333333;
L10:
    b = a - (float)1.;
    c = b + b + b;
    eps = (r__1 = c - (float)1., dabs(r__1));
    if (eps == (float)0.) {
	goto L10;
    }
    ret_val = eps * dabs(*x);
    return ret_val;
} /* epslon_ */

/* Subroutine */ int smxpy_(n1, y, n2, ldm, x, m)
integer *n1;
real *y;
integer *n2, *ldm;
real *x, *m;
{
    /* System generated locals */
    integer m_dim1, m_offset, i__1, i__2;

    /* Local variables */
    static integer jmin, i, j;


/*   PURPOSE: */
/*     MULTIPLY MATRIX M TIMES VECTOR X AND ADD THE RESULT TO VECTOR Y. */


/*   PARAMETERS: */

/*     N1 INTEGER, NUMBER OF ELEMENTS IN VECTOR Y, AND NUMBER OF ROWS IN 
*/
/*         MATRIX M */

/*     Y REAL(N1), VECTOR OF LENGTH N1 TO WHICH IS ADDED THE PRODUCT M*X 
*/

/*     N2 INTEGER, NUMBER OF ELEMENTS IN VECTOR X, AND NUMBER OF COLUMNS 
*/
/*         IN MATRIX M */

/*     LDM INTEGER, LEADING DIMENSION OF ARRAY M */

/*     X REAL(N2), VECTOR OF LENGTH N2 */

/*     M REAL(LDM,N2), MATRIX OF N1 ROWS AND N2 COLUMNS */

/* ---------------------------------------------------------------------- 
*/

/*   CLEANUP ODD VECTOR */

    /* Parameter adjustments */
    m_dim1 = *ldm;
    m_offset = m_dim1 + 1;
    m -= m_offset;
    --x;
    --y;

    /* Function Body */
    j = *n2 % 2;
    if (j >= 1) {
	i__1 = *n1;
	for (i = 1; i <= i__1; ++i) {
	    y[i] += x[j] * m[i + j * m_dim1];
/* L10: */
	}
    }

/*   CLEANUP ODD GROUP OF TWO VECTORS */

    j = *n2 % 4;
    if (j >= 2) {
	i__1 = *n1;
	for (i = 1; i <= i__1; ++i) {
	    y[i] = y[i] + x[j - 1] * m[i + (j - 1) * m_dim1] + x[j] * m[i + j 
		    * m_dim1];
/* L20: */
	}
    }

/*   CLEANUP ODD GROUP OF FOUR VECTORS */

    j = *n2 % 8;
    if (j >= 4) {
	i__1 = *n1;
	for (i = 1; i <= i__1; ++i) {
	    y[i] = y[i] + x[j - 3] * m[i + (j - 3) * m_dim1] + x[j - 2] * m[i 
		    + (j - 2) * m_dim1] + x[j - 1] * m[i + (j - 1) * m_dim1] 
		    + x[j] * m[i + j * m_dim1];
/* L30: */
	}
    }

/*   CLEANUP ODD GROUP OF EIGHT VECTORS */

    j = *n2 % 16;
    if (j >= 8) {
	i__1 = *n1;
	for (i = 1; i <= i__1; ++i) {
	    y[i] = y[i] + x[j - 7] * m[i + (j - 7) * m_dim1] + x[j - 6] * m[i 
		    + (j - 6) * m_dim1] + x[j - 5] * m[i + (j - 5) * m_dim1] 
		    + x[j - 4] * m[i + (j - 4) * m_dim1] + x[j - 3] * m[i + (
		    j - 3) * m_dim1] + x[j - 2] * m[i + (j - 2) * m_dim1] + x[
		    j - 1] * m[i + (j - 1) * m_dim1] + x[j] * m[i + j * 
		    m_dim1];
/* L40: */
	}
    }

/*   MAIN LOOP - GROUPS OF SIXTEEN VECTORS */

    jmin = j + 16;
    i__1 = *n2;
    for (j = jmin; j <= i__1; j += 16) {
	i__2 = *n1;
	for (i = 1; i <= i__2; ++i) {
	    y[i] = y[i] + x[j - 15] * m[i + (j - 15) * m_dim1] + x[j - 14] * 
		    m[i + (j - 14) * m_dim1] + x[j - 13] * m[i + (j - 13) * 
		    m_dim1] + x[j - 12] * m[i + (j - 12) * m_dim1] + x[j - 11]
		     * m[i + (j - 11) * m_dim1] + x[j - 10] * m[i + (j - 10) *
		     m_dim1] + x[j - 9] * m[i + (j - 9) * m_dim1] + x[j - 8] *
		     m[i + (j - 8) * m_dim1] + x[j - 7] * m[i + (j - 7) * 
		    m_dim1] + x[j - 6] * m[i + (j - 6) * m_dim1] + x[j - 5] * 
		    m[i + (j - 5) * m_dim1] + x[j - 4] * m[i + (j - 4) * 
		    m_dim1] + x[j - 3] * m[i + (j - 3) * m_dim1] + x[j - 2] * 
		    m[i + (j - 2) * m_dim1] + x[j - 1] * m[i + (j - 1) * 
		    m_dim1] + x[j] * m[i + j * m_dim1];
/* L50: */
	}
/* L60: */
    }
    return 0;
} /* smxpy_ */

#include <process.h>
doublereal second_()
{
    /* System generated locals */
    real ret_val;
    ret_val = (float)ProcTime()/15625.0;
/*      SECOND = F_TIMER() /15625 */
    return ret_val;
} /* second_ */

