/*	Type definitions used by VCP that are exported to TCL 
*/
#ifndef VCP_EXTYPE_H
#define VCP_EXTYPE_H

/*	List of packets received
	NOTE : qlink should be the first element of the structure
*/
typedef struct message_list {
	QUEUE_CHAIN	qlink;		/* Pointer to next message	*/
	char		*MessagePtr;	/* Message buffer		*/
}MESSAGE_LIST;

/*	Process descriptor on a transputer 
*/
typedef long WDESC_TYPE;

/*	Priorities in a transputer
*/
typedef enum { High=0, Low=1 }PRIORITY_TYPE;

#endif
