#include	<sys/transp.h>
#include	<sys/crt.h>

/*	Assembly routines to support suspending and resuming of
	processes and altering process priorities
*/

.text
.globl	_ProcSleep

_ProcSleep:
	ldlp 	0
	ldpri
	or
	ldl	SYS_fnent_argptr
	ldnl	0
	stnl	0
	stopp
	ret


.globl _ProcAwaken

_ProcAwaken:
	ldl	SYS_fnent_argptr		
	ldnl	0
	runp
	ret

.globl _ProcGetPri

_ProcGetPri:
	ldpri
	ldl	SYS_fnent_argptr
	ldnl	0
	stnl	0
	ret

.globl	_ProcToLow

_ProcToLow:
	ldlp	0
	ldc	1
	or
	runp
	stopp
	ret

.globl	_ProcToHigh

_ProcToHigh:
	ldc	.L3-.L1
	.align	4
	ldpi
.L1:
	stl 	-1
	ldlp	0
	ldc	-1
	and
	runp
	ldc	.L3-.L2
	ldpi
.L2:
	gajw
	stopp
	.align	4
	.word	0x20202020
.L3:
	ret


